'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _process = require('process');

var _process2 = _interopRequireDefault(_process);

var _superagent = require('superagent');

var _superagent2 = _interopRequireDefault(_superagent);

var _mkdirp = require('mkdirp');

var _mkdirp2 = _interopRequireDefault(_mkdirp);

var _mime = require('mime');

var _mime2 = _interopRequireDefault(_mime);

var _bluebird = require('bluebird');

var _margarita = require('margarita');

var _margarita2 = _interopRequireDefault(_margarita);

var _inquirer = require('inquirer');

var _inquirer2 = _interopRequireDefault(_inquirer);

var _jsonwebtoken = require('jsonwebtoken');

var _jsonwebtoken2 = _interopRequireDefault(_jsonwebtoken);

var _eachLimit = require('async/eachLimit');

var _eachLimit2 = _interopRequireDefault(_eachLimit);

var _mapLimit = require('async/mapLimit');

var _mapLimit2 = _interopRequireDefault(_mapLimit);

var _asyncify = require('async/asyncify');

var _asyncify2 = _interopRequireDefault(_asyncify);

var _underscore = require('underscore');

var _underscore2 = _interopRequireDefault(_underscore);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _progress = require('progress');

var _progress2 = _interopRequireDefault(_progress);

var _traverse = require('./traverse');

var _traverse2 = _interopRequireDefault(_traverse);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

require("babel-polyfill");

var CONFIG_PATH = _path2.default.resolve(_os2.default.homedir(), '.config/puche');

// const HOST = "http://api.staging.puche.io";
var HOST = "http://api.puche.io";

var config = {
    apiKey: "AIzaSyBtdHYms6uGue_ZmwlNtGCMol2SThyaZBs",
    authDomain: "puche-io.firebaseapp.com"
};

// var config = {
//     apiKey: "AIzaSyDQRgfrzWK2GYMDOjMkJ9xaXoi8SlWrcUM",
//     authDomain: "staging-puche-io.firebaseapp.com"
// };

var upload = function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref) {
        var siteId = _ref.siteId;
        var jwtToken, tokenFile, token, tokenObject, files, fileGroups, bar, fileUploads, configFile, response;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        jwtToken = void 0;
                        _context3.prev = 1;
                        _context3.next = 4;
                        return (0, _bluebird.promisify)(_fs2.default.readFile)(_path2.default.join(CONFIG_PATH, 'token'));

                    case 4:
                        tokenFile = _context3.sent;

                        jwtToken = JSON.parse(tokenFile);
                        _context3.next = 13;
                        break;

                    case 8:
                        _context3.prev = 8;
                        _context3.t0 = _context3['catch'](1);
                        _context3.next = 12;
                        return auth();

                    case 12:
                        jwtToken = _context3.sent;

                    case 13:
                        token = jwtToken.idToken;
                        tokenObject = _jsonwebtoken2.default.decode(token);

                        if (!(tokenObject.exp < new Date().getTime() / 1000)) {
                            _context3.next = 19;
                            break;
                        }

                        _context3.next = 18;
                        return refreshToken(jwtToken);

                    case 18:
                        token = _context3.sent.id_token;

                    case 19:
                        _context3.next = 21;
                        return (0, _traverse2.default)('.');

                    case 21:
                        files = _context3.sent;


                        console.log('Uploading ' + files.length + ' files to ' + _chalk2.default.keyword('orange')(siteId));

                        fileGroups = _underscore2.default.map(_underscore2.default.groupBy(files, function (file, index) {
                            return Math.floor(index / 50);
                        }), function (fileList, index) {
                            return { fileList: fileList, index: index };
                        });
                        bar = new _progress2.default('Progress [:bar] :percent', {
                            complete: '=',
                            incomplete: ' ',
                            width: 40,
                            total: files.length * 2
                        });

                        bar.tick(0);

                        _context3.next = 28;
                        return (0, _bluebird.promisify)(_mapLimit2.default)(fileGroups, 1, (0, _asyncify2.default)(function () {
                            var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref3) {
                                var fileList = _ref3.fileList,
                                    index = _ref3.index;
                                var response;
                                return regeneratorRuntime.wrap(function _callee$(_context) {
                                    while (1) {
                                        switch (_context.prev = _context.next) {
                                            case 0:
                                                _context.next = 2;
                                                return _superagent2.default.post(HOST + '/api/v1/signUploads').set("Authorization", token).send({
                                                    site: siteId,
                                                    uploads: fileList.map(function (file) {
                                                        return {
                                                            contentType: _mime2.default.lookup(file),
                                                            path: _path2.default.relative(_process2.default.cwd(), file)
                                                        };
                                                    })
                                                });

                                            case 2:
                                                response = _context.sent;


                                                bar.tick(response.body.signedUploads.length);

                                                return _context.abrupt('return', _underscore2.default.zip(fileList, response.body.signedUploads).map(function (_ref5) {
                                                    var _ref6 = _slicedToArray(_ref5, 2),
                                                        file = _ref6[0],
                                                        url = _ref6[1];

                                                    return { file: file, url: url };
                                                }));

                                            case 5:
                                            case 'end':
                                                return _context.stop();
                                        }
                                    }
                                }, _callee, this);
                            }));

                            return function (_x2) {
                                return _ref4.apply(this, arguments);
                            };
                        }()));

                    case 28:
                        fileUploads = _context3.sent;
                        _context3.next = 31;
                        return (0, _bluebird.promisify)(_eachLimit2.default)(_underscore2.default.flatten(fileUploads), 20, (0, _asyncify2.default)(function () {
                            var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(fileUpload) {
                                var data;
                                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                                    while (1) {
                                        switch (_context2.prev = _context2.next) {
                                            case 0:
                                                _context2.next = 2;
                                                return (0, _bluebird.promisify)(_fs2.default.readFile)(fileUpload.file);

                                            case 2:
                                                data = _context2.sent;
                                                _context2.next = 5;
                                                return _superagent2.default.put(fileUpload.url).set("Content-Type", _mime2.default.lookup(fileUpload.file)).set("Cache-Control", "public, max-age=60").set("x-goog-acl", "public-read").send(data);

                                            case 5:

                                                bar.tick(1);

                                            case 6:
                                            case 'end':
                                                return _context2.stop();
                                        }
                                    }
                                }, _callee2, this);
                            }));

                            return function (_x3) {
                                return _ref7.apply(this, arguments);
                            };
                        }()));

                    case 31:
                        _context3.t1 = JSON;
                        _context3.next = 34;
                        return (0, _bluebird.promisify)(_fs2.default.readFile)(_path2.default.join(_process2.default.cwd(), 'puche.json'));

                    case 34:
                        _context3.t2 = _context3.sent;
                        configFile = _context3.t1.parse.call(_context3.t1, _context3.t2);


                        console.log(configFile);

                        _context3.next = 39;
                        return _superagent2.default.put(HOST + '/api/v1/accounts/m2y71RMM96A/sites/' + siteId + '/config').set("Authorization", token).send(configFile);

                    case 39:
                        response = _context3.sent;


                        console.log("Upload Complete.");

                    case 41:
                    case 'end':
                        return _context3.stop();
                }
            }
        }, _callee3, this, [[1, 8]]);
    }));

    return function upload(_x) {
        return _ref2.apply(this, arguments);
    };
}();

var signIn = function () {
    var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(email, password) {
        var response;
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return _superagent2.default.post('https://www.googleapis.com/identitytoolkit/v3/relyingparty/verifyPassword?key=' + config['apiKey']).send({
                            email: email,
                            password: password,
                            returnSecureToken: true
                        });

                    case 2:
                        response = _context4.sent;
                        return _context4.abrupt('return', response.body);

                    case 4:
                    case 'end':
                        return _context4.stop();
                }
            }
        }, _callee4, this);
    }));

    return function signIn(_x4, _x5) {
        return _ref8.apply(this, arguments);
    };
}();

var refreshToken = function () {
    var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(jwtToken) {
        var response;
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
            while (1) {
                switch (_context5.prev = _context5.next) {
                    case 0:
                        _context5.next = 2;
                        return _superagent2.default.post('https://securetoken.googleapis.com/v1/token?key=' + config['apiKey']).send({
                            grant_type: 'refresh_token',
                            refreshToken: jwtToken.refreshToken
                        });

                    case 2:
                        response = _context5.sent;
                        return _context5.abrupt('return', response.body);

                    case 4:
                    case 'end':
                        return _context5.stop();
                }
            }
        }, _callee5, this);
    }));

    return function refreshToken(_x6) {
        return _ref9.apply(this, arguments);
    };
}();

var auth = function () {
    var _ref10 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        var results, tokenResponse;
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.next = 2;
                        return _inquirer2.default.prompt([{ type: 'input', message: "Username", name: "username" }, { type: 'password', message: "Password", name: "password" }]);

                    case 2:
                        results = _context6.sent;
                        _context6.next = 5;
                        return signIn(results['username'], results['password']);

                    case 5:
                        tokenResponse = _context6.sent;
                        _context6.next = 8;
                        return (0, _bluebird.promisify)(_mkdirp2.default)(CONFIG_PATH);

                    case 8:
                        _context6.next = 10;
                        return (0, _bluebird.promisify)(_fs2.default.writeFile)(_path2.default.join(CONFIG_PATH, 'token'), JSON.stringify(tokenResponse));

                    case 10:
                        return _context6.abrupt('return', tokenResponse);

                    case 11:
                    case 'end':
                        return _context6.stop();
                }
            }
        }, _callee6, this);
    }));

    return function auth() {
        return _ref10.apply(this, arguments);
    };
}();

var writeToken = function () {
    var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(tokenObj) {
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
            while (1) {
                switch (_context7.prev = _context7.next) {
                    case 0:
                        _context7.next = 2;
                        return (0, _bluebird.promisify)(_mkdirp2.default)(CONFIG_PATH);

                    case 2:
                        return _context7.abrupt('return', (0, _bluebird.promisify)(_fs2.default.writeFile)(_path2.default.join(CONFIG_PATH, 'token'), JSON.stringify(tokenResponse.body)));

                    case 3:
                    case 'end':
                        return _context7.stop();
                }
            }
        }, _callee7, this);
    }));

    return function writeToken(_x7) {
        return _ref11.apply(this, arguments);
    };
}();

var program = (0, _margarita2.default)();

program.command('auth').action(function (args) {
    auth().catch(function (e) {
        return console.error("Error:", e);
    });
});

program.command('upload').option('s', 'site').action(function (args) {
    upload({ siteId: args.site }).catch(function (e) {
        return console.error("Error:", e);
    });
});

program.parse(_process2.default.argv).catch(function (e) {
    return console.error("NoCommand Error:", e);
});